Bug 1468939 - Review Request: ocaml-gen - Simple, efficient iterators for OCaml
Review Request: ocaml-gen - Simple, efficient iterators for OCaml
Status: ON_QA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Robert-André Mauchin
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-07-09 23:44 EDT by Andy Li
Modified: 2017-12-02 17:38 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
zebob.m: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Andy Li 2017-07-09 23:44:29 EDT
Spec URL: https://gist.github.com/andyli/95317afac226cfb21c6507a51ad346ff/raw/4f7199fa014752cb998ce33c7615fe3b35641f3f/ocaml-gen.spec
SRPM URL: https://gist.github.com/andyli/95317afac226cfb21c6507a51ad346ff/raw/4f7199fa014752cb998ce33c7615fe3b35641f3f/ocaml-gen-0.4.0.1-1.fc27.src.rpm
Description: Simple, efficient iterators for OCaml
Fedora Account System Username: andyli

This is a dependency of sedlex, which in turn is a new dependency
of the next version of Haxe (v4.0.0).
Comment 2 Robert-André Mauchin 2017-09-12 06:41:55 EDT
Hello,

A few points:

 - Group: is not used in Fedora, please remove it.

 - You can simplify your Source0 like this:

Source0:        https://github.com/c-cube/gen/archive/%{version}/%{name}-%{version}.tar.gz

 - Use macros: make → %make_build

 - rm -rf $RPM_BUILD_ROOT is not needed in %install

 - The typical BR is ocaml-findlib, not ocaml-findlib-devel

 - Please slit your BR per line:

BuildRequires:  ocaml
BuildRequires:  ocaml-findlib
BuildRequires:  ocaml-ocamldoc
BuildRequires:  ocaml-ocamlbuild

 - I don't think this is needed:

%global _use_internal_dependency_generator 0
%global __find_requires /usr/lib/rpm/ocaml-find-requires.sh
%global __find_provides /usr/lib/rpm/ocaml-find-provides.sh

As you can see below, the Requires and Provides are correctly generated without this:

Requires
--------
ocaml-gen (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    ocaml(Array)
    ocaml(Buffer)
    ocaml(CamlinternalFormatBasics)
    ocaml(CamlinternalOO)
    ocaml(Format)
    ocaml(GenLabels_intf)
    ocaml(GenM_intf)
    ocaml(Gen_intf)
    ocaml(Int32)
    ocaml(Int64)
    ocaml(List)
    ocaml(Nativeint)
    ocaml(Obj)
    ocaml(Pervasives)
    ocaml(Queue)
    ocaml(Random)
    ocaml(String)
    ocaml(runtime)
    rtld(GNU_HASH)

ocaml-gen-devel (rpmlib, GLIBC filtered):
    ocaml-gen(x86-64)


Provides
--------
ocaml-gen:
    ocaml(Gen)
    ocaml(GenClone)
    ocaml(GenLabels)
    ocaml(GenLabels_intf)
    ocaml(GenM)
    ocaml(GenMList)
    ocaml(GenM_intf)
    ocaml(Gen_intf)
    ocaml-gen
    ocaml-gen(x86-64)

ocaml-gen-devel:
    ocaml-gen-devel
    ocaml-gen-devel(x86-64)


 - Use the macro: %ifarch %{ocaml_native_compiler}
   instead of %if %opt (and thus, remove the macro definition for %opt)



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (2 clause)", "Unknown or generated", "*No copyright* BSD
     (3 clause)". 34 files have unknown license. Detailed output of
     licensecheck in /home/bob/packaging/review/ocaml-gen/review-ocaml-
     gen/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 737280 bytes in 65 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Ocaml:
[x]: This should never happen

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ocaml-gen-0.4.0.1-1.fc28.x86_64.rpm
          ocaml-gen-devel-0.4.0.1-1.fc28.x86_64.rpm
          ocaml-gen-0.4.0.1-1.fc28.src.rpm
ocaml-gen.x86_64: W: spelling-error %description -l en_US restartable -> restart able, restart-able, respectable
ocaml-gen.x86_64: W: unstripped-binary-or-object /usr/lib64/ocaml/gen/gen.cmxs
ocaml-gen.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
ocaml-gen.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
ocaml-gen.src: W: spelling-error %description -l en_US restartable -> restart able, restart-able, respectable
ocaml-gen.src:36: W: configure-without-libdir-spec
3 packages and 0 specfiles checked; 0 errors, 6 warnings.
Comment 4 Robert-André Mauchin 2017-09-27 02:58:01 EDT
All okay, package accepted.
Comment 5 Andy Li 2017-10-10 10:15:09 EDT
Thanks!

I can't remember what is the next step for me to do to get the package actually appear in Fedora...
Will a git repo created automatically or I have to find a sponsor or something?
Comment 6 Robert-André Mauchin 2017-10-10 11:35:22 EDT
You are already member of the packager group so you don't need any sponsor.

Fedora has changed the way to request package since August. We are now using a tool called fedrepo-req. See the help here https://pagure.io/fedrepo_req

First look at the Configuration section:

 - you need to log on https://src.fedoraproject.org/
 - there request a new token https://pagure.io/settings/token/new
 - this token is valid for two months
 - paste the token in ~/.config/fedrepo_req/config.ini like this:

[app]
pagure_api_token = <api_key_here>


Step 2: now request a new repo for your package (see the Usage section for details) with you bugzilla bug number:

$ fedrepo-req ocaml-gen -t 1468639 --monitor monitoring

You can also request new branches for f27, f26, epel7… with:

$ fedrepo-req-branch ocaml-gen f27

In both case, you will be given a ticket number (list of tickets are here https://pagure.io/releng/fedora-scm-requests/issues ). These tickets are processed by a human' they are generally approved within a day or two.

Step 3: Once your tickets are approved, you can clone the newly created repo:

$ fedpkg clone ocaml-gen

(If you've got an authentication error, make sure you are authenticated with Kerberos: $ KRB5_TRACE=/dev/stdout kinit andyli@FEDORAPROJECT.ORG )

Then you can import your SRPM:

$ cd ocaml-gen
$ fedpkg import /path/to/your/srpm

Commit the change like this:

$ fedpkg commit -m "Initial import (#1468639)"

Then push it to the repo:

$ fedpkg push

Now that the package is pushed, you can build it in Koji:

$ fedpkg build

If everything is fine, your package will be built on all relevant arches.
It will then be available on Rawhide in the next compose check.

If you have requested more branches, you can now process them too. First we switch to the version for which we want to build:

$ fedpkg switch-branch f27

Then since it's a new package, we merge master into the new branch:

$ git merge master

We push the new branch:

$ fedpkg push

And finally we can build the package for f27:

$ fedpkg build

When the building is done, you can request a Bodhi ticket in order to have the package included as an update:

$ fedpkg update

Fill the requested information (newpackage and this bug number), then save. You will be given a "receipt" acknowledging the request. The package will then be available in updates-testing shortly.

You can process other branch f26, epel7… the same way. Finally switch back to master when you're done:

$ fedpkg switch-branch master
Comment 7 Gwyn Ciesla 2017-10-11 08:50:21 EDT
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/ocaml-gen
Comment 8 Fedora Update System 2017-11-28 01:06:10 EST
ocaml-gen-0.5-1.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2017-0be154757d
Comment 9 Fedora Update System 2017-11-28 20:46:29 EST
ocaml-gen-0.5-1.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-0be154757d
Comment 10 Fedora Update System 2017-11-28 21:00:59 EST
ocaml-gen-0.5-1.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-a30e27ba2a
Comment 11 Fedora Update System 2017-12-02 17:38:02 EST
ocaml-gen-0.5-1.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-a30e27ba2a

Note You need to log in before you can comment on or make changes to this bug.